/***********************************************************************************************************************
 *
 * blueBill Core - open source birding
 * Copyright (C) 2009-2011 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://bluebill.tidalwave.it
 * SCM: https://java.net/hg/bluebill~core-src
 *
 **********************************************************************************************************************/
package it.tidalwave.semantic.io.spi;

import org.openrdf.model.Statement;
import javax.annotation.Nonnull;
import java.util.Collection;
import java.util.List;
import it.tidalwave.util.As;
import it.tidalwave.util.Id;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
public interface StatementUnmarshaller
  {
    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    public static interface Context
      {
        @Nonnull
        public Object find (@Nonnull Object object);
         
        public void push (@Nonnull Object object);

        public void pop();

        @Nonnull
        public Object peek();

        @Nonnull
        public Collection<Statement> findStatements (@Nonnull Id predicate, @Nonnull Id object);
      }

    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    @Nonnull
    public As unmarshal (@Nonnull List<Statement> statements, @Nonnull Context context);
  }
